/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome:  7790_PLASTPS.SQL

Descrio: Realiza a cpia de pratos e receitas de uma filial para outra.

Parmetros de entrada:

Criao:
Rafael Lopes - 19/03/2004

*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'INTEGRA_RECEITA_CENTRALIZADA' AND
	        TYPE = 'P' 			         AND
	        U.UID = O.UID             	AND
	        U.NAME = USER)
DROP PROCEDURE INTEGRA_RECEITA_CENTRALIZADA;
GO

CREATE PROCEDURE INTEGRA_RECEITA_CENTRALIZADA
    @P_CDFILIORIG  VARCHAR(4),
    @P_CDFILIDEST  VARCHAR(4),
    @P_NRLISTA     VARCHAR(10),
    @P_IDTIPORECE  VARCHAR(2),
    @P_NRLOGINTCENT VARCHAR(10) OUTPUT
    
AS
   DECLARE @V_IDRECEFILI VARCHAR(1);
   DECLARE @V_IDRECESERV VARCHAR(1);
   DECLARE @V_SERVORIGDEST VARCHAR(2000);
   DECLARE @V_NRLOGINTCENT VARCHAR(10);

   DECLARE @V_IDOPERACAOP VARCHAR(1);
   DECLARE @V_IDOPERACAOR VARCHAR(1);
   DECLARE @V_FILAUXDEST VARCHAR(4);
   DECLARE @V_CONTPRAT NUMERIC;
   DECLARE @V_EXISTS NUMERIC;
   DECLARE @V_ERROS NUMERIC;
   DECLARE @V_PRATOS NUMERIC;
   DECLARE @V_PRATNMDUPL NUMERIC;
   DECLARE @V_CONTRECEF NUMERIC;
   DECLARE @V_CONTRF NUMERIC;
   DECLARE @V_CONTRS NUMERIC;
   DECLARE @V_CONTRECES NUMERIC;
   DECLARE @V_NMPRATODEST VARCHAR(40);
   DECLARE @V_CDPRATO VARCHAR(10);
   DECLARE @V_PRODUTO VARCHAR(10);
   DECLARE @V_CDFILAUX VARCHAR(4);

   /* VARIVEIS PARA CONTROLE DE CURSORES */


   DECLARE @C_PRATOSORIG_CDPRATO VARCHAR(10);
   DECLARE @C_PRATOSORIG_CDFILAUXPRAT VARCHAR(4);
   DECLARE @C_PRATOSORIG_NMPRATO VARCHAR(40);
   DECLARE @C_PRATOSORIG_CDNVPRATO VARCHAR(1);
   DECLARE @C_PRATOSORIG_SGUNIDADE VARCHAR(10);
   DECLARE @C_PRATOSORIG_VRARREDTRANS NUMERIC;
   DECLARE @C_PRATOSORIG_CDSEGMER VARCHAR(5);
   DECLARE @C_PRATOSORIG_CDEXPRATO VARCHAR(20);
   DECLARE @C_PRATERRO_RECEITA VARCHAR(1);  
   DECLARE @C_PRATERRO_CDPRODUTO VARCHAR(10);
   DECLARE @C_PRATERRO_IDCNTRESTOQ VARCHAR(1);
   DECLARE @C_PRATERRO_IDPRODATIV VARCHAR(1);
   DECLARE @C_PRATERRO_IDPRODATIVPR VARCHAR(1);
   DECLARE @C_PRATERRO_IDCTRLESTQ VARCHAR(1);

   DECLARE @C_SERVICO_CDSERVFILI VARCHAR(5);
   DECLARE @C_SERVICO_NMSERVICO VARCHAR(40);
BEGIN
   /* FORMATO P_IDTIPORECE = 'FS' ou 'XX' */
   SET @V_IDRECEFILI = SUBSTRING(@P_IDTIPORECE,1,1);
   SET @V_IDRECESERV = SUBSTRING(@P_IDTIPORECE,2,1);
   SET @V_NRLOGINTCENT = '';
   SET @V_ERROS = 0;

   SELECT 
   @V_NRLOGINTCENT = CASE ISNULL(MAX(NRLOGINTCENT), 0) 
               WHEN 0 THEN
                 RIGHT(REPLICATE('0', 10)+'1', 10)
               ELSE RIGHT(REPLICATE('0', 10)+ CONVERT(VARCHAR, MAX(NRLOGINTCENT)+1, 103), 10)
               END
    FROM LOGINTRECCENT;

   DECLARE C_PRATOSORIG CURSOR FOR
      SELECT
         P.CDPRATO,
         P.CDFILAUXPRAT,
         P.NMPRATO,
         P.CDNVPRATO,
         P.SGUNIDADE,
         P.VRARREDTRANS,
         P.CDSEGMER,

         P.CDEXPRATO
      FROM 
         PRATO P,
         LISTA L
      WHERE
         L.NRLISTA = @P_NRLISTA AND
         P.CDFILAUXPRAT+P.CDPRATO = L.CDLISTA
      ORDER BY 
         P.CDPRATO, 
         P.CDFILAUXPRAT;

   OPEN C_PRATOSORIG;
   FETCH NEXT FROM C_PRATOSORIG INTO @C_PRATOSORIG_CDPRATO,
                                     @C_PRATOSORIG_CDFILAUXPRAT,
                                     @C_PRATOSORIG_NMPRATO,
                                     @C_PRATOSORIG_CDNVPRATO,
                                     @C_PRATOSORIG_SGUNIDADE,
                                     @C_PRATOSORIG_VRARREDTRANS,
                                     @C_PRATOSORIG_CDSEGMER,
                                     @C_PRATOSORIG_CDEXPRATO;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_EXISTS = 0;
      SET @V_CONTRF = 0;
      SET @V_CONTRS = 0;
      SET @V_PRATOS = 0;
      /* 'I' - IGNORAR  */
      /* 'S' - SOBREPOR */
      SET @V_IDOPERACAOP = 'S';
      SET @V_PRATNMDUPL = 0;
      SET @V_PRODUTO = '';
      IF (@C_PRATOSORIG_CDFILAUXPRAT <> 'P') BEGIN
         SELECT
           @V_PRATNMDUPL = COUNT(*) FROM(
            SELECT D.NMPRATO, O.NMPRATO AS NMPRATO2
              FROM PRATO O, PRATO D
             WHERE O.CDPRATO = @C_PRATOSORIG_CDPRATO
               AND O.CDPRATO = D.CDPRATO
               AND (RTRIM(LTRIM(UPPER(O.NMPRATO))) <> RTRIM(LTRIM(UPPER(D.NMPRATO))))
               AND D.CDFILAUXPRAT = @P_CDFILIDEST
               AND O.CDFILAUXPRAT = @P_CDFILIORIG) A;

            SELECT
              @V_PRODUTO = MAX(CDPRODUTO)
              FROM PRODUTO;

         SET @V_FILAUXDEST = @P_CDFILIDEST;
      END
      ELSE BEGIN
         SET @V_FILAUXDEST = 'P';
      END;
      DECLARE C_PRATERRO CURSOR FOR
           SELECT 'L' AS RECEITA, PR.CDPRODUTO, PF.IDCNTRESTOQ, PF.IDPRODATIV,
                  PR.IDPRODATIVPR, PL.IDCTRLESTQ
             FROM PRATO PO,
                  RECEFILI RF, (SELECT @P_CDFILIDEST AS CDFILIAL) AS FILIAUX
                                       LEFT JOIN PARAMFILIAL PL ON (FILIAUX.CDFILIAL = PL.CDFILIAL),
                  PRODUTO PR LEFT JOIN PRODFILI PF ON (PR.CDPRODUTO = PF.CDPRODUTO)
                                                   AND(@P_CDFILIDEST = PF.CDFILIAL)
            WHERE PO.CDPRATO = RF.CDPRATO
              AND PO.CDFILAUXPRAT = RF.CDFILAUXPRAT
              AND RF.CDPRODUTO = PR.CDPRODUTO
              AND PO.CDPRATO = @C_PRATOSORIG_CDPRATO
              AND PO.CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT
              AND RF.CDFILIAL = @P_CDFILIORIG
              AND (@V_IDRECEFILI = 'F')
              AND ((ISNULL(PF.IDPRODATIV, 'A') = 'I') OR (ISNULL(PR.IDPRODATIVPR, 'S') = 'N') OR
                  (ISNULL(PF.IDCNTRESTOQ, 'S') = 'N') OR (ISNULL(PL.IDCTRLESTQ, 'S') = 'N'))
            UNION ALL
           SELECT DISTINCT *
             FROM (SELECT 'S' AS RECEITA, PR2.CDPRODUTO, PF2.IDCNTRESTOQ, PF2.IDPRODATIV,
                          PR2.IDPRODATIVPR, PL2.IDCTRLESTQ
                     FROM PRATO PO2,
                          RECESERV RS2, (SELECT @P_CDFILIDEST AS CDFILIAL) AS FILIAUX2
                                         LEFT JOIN PARAMFILIAL PL2 ON(FILIAUX2.CDFILIAL = PL2.CDFILIAL),
                          PRODUTO PR2 LEFT JOIN PRODFILI PF2 ON (PR2.CDPRODUTO = PF2.CDPRODUTO)
                                                              AND(@P_CDFILIDEST = PF2.CDFILIAL),
		               (SELECT
		                   O.CDSERVFILI, O.NMSERVICO
		                FROM
                		   SERVICO O,
		                   SERVICO D
                		WHERE
		                   (O.CDFILIAL = @P_CDFILIORIG) AND
                		   (D.CDFILIAL = @P_CDFILIDEST) AND
		                   (O.CDSERVFILI = D.CDSERVFILI) AND
                		   (UPPER(RTRIM(LTRIM(O.NMSERVICO))) = UPPER(RTRIM(LTRIM(D.NMSERVICO)))) AND
		                   EXISTS(SELECT CDPRATO
                		          FROM RECESERV
		                          WHERE
                		             CDPRATO = @C_PRATOSORIG_CDPRATO AND
		                             CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT AND
                		             CDFILIAL = @P_CDFILIORIG AND
                                	     CDSERVFILI = O.CDSERVFILI)) SERV
                    WHERE PO2.CDPRATO = RS2.CDPRATO
                      AND PO2.CDFILAUXPRAT = RS2.CDFILAUXPRAT
                      AND RS2.CDPRODUTO = PR2.CDPRODUTO
                      AND PO2.CDPRATO = @C_PRATOSORIG_CDPRATO
                      AND PO2.CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT
                      AND RS2.CDFILIAL = @P_CDFILIORIG
                      AND RS2.CDSERVFILI = SERV.CDSERVFILI
                      AND (@V_IDRECESERV = 'S')
                      AND ((ISNULL(PF2.IDPRODATIV, 'A') = 'I') OR (ISNULL(PR2.IDPRODATIVPR, 'S') = 'N') OR
                          (ISNULL(PF2.IDCNTRESTOQ, 'S') = 'N') OR (ISNULL(PL2.IDCTRLESTQ, 'S') = 'N'))) A;
      OPEN C_PRATERRO;
      FETCH NEXT FROM C_PRATERRO INTO   @C_PRATERRO_RECEITA,
                                        @C_PRATERRO_CDPRODUTO,
                                        @C_PRATERRO_IDCNTRESTOQ,
                                        @C_PRATERRO_IDPRODATIV,
                                        @C_PRATERRO_IDPRODATIVPR,
                                        @C_PRATERRO_IDCTRLESTQ;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF ((@C_PRATERRO_IDPRODATIV = 'I') OR (@C_PRATERRO_IDPRODATIVPR = 'N')) BEGIN

            SET @V_EXISTS = @V_EXISTS + 1;
            INSERT INTO LOGINTRECCENT
                (NRLOGINTCENT,
                 CDFILDESTLOG,
                 CDPRATOLOG,
                 CDFAPRAORIGLOG,
                 CDFAPRADESTL,
                 CDFILORIGLOGREC,
                 CDPRODUTO,
                 IDTIPORECELOG,
                 IDNUMEROERRO)
             VALUES
               (@V_NRLOGINTCENT,
                @P_CDFILIDEST,
                @C_PRATOSORIG_CDPRATO,
                @C_PRATOSORIG_CDFILAUXPRAT,
                @V_FILAUXDEST,
                @P_CDFILIORIG,
                @C_PRATERRO_CDPRODUTO,
                @C_PRATERRO_RECEITA,
                '0');
         END;

         IF (@V_IDRECEFILI = 'F') BEGIN
            IF (@C_PRATERRO_RECEITA = 'L') BEGIN
               SET @V_CONTRF = (@V_CONTRF+1);
            END;
         END;
         IF (@V_IDRECESERV = 'S') BEGIN
	    IF (@C_PRATERRO_RECEITA = 'S') BEGIN
               SET @V_CONTRS = (@V_CONTRS+1);
            END;
         END;

         IF ((@C_PRATERRO_IDCNTRESTOQ = 'N') OR (@C_PRATERRO_IDCTRLESTQ = 'N')) BEGIN

            SET @V_EXISTS = (@V_EXISTS + 1);
            INSERT INTO LOGINTRECCENT
                (NRLOGINTCENT,
                 CDFILDESTLOG,
                 CDPRATOLOG,
                 CDFAPRAORIGLOG,
                 CDFAPRADESTL,
                 CDFILORIGLOGREC,
                 CDPRODUTO,
                 IDTIPORECELOG,
                 IDNUMEROERRO)
            VALUES
                (@V_NRLOGINTCENT,
                 @P_CDFILIDEST,
                 @C_PRATOSORIG_CDPRATO,
                 @C_PRATOSORIG_CDFILAUXPRAT,
                 @V_FILAUXDEST,
                 @P_CDFILIORIG,
                 @C_PRATERRO_CDPRODUTO,
                 @C_PRATERRO_RECEITA,
                 '1');
         END;
         FETCH NEXT FROM C_PRATERRO INTO    @C_PRATERRO_RECEITA,
                                            @C_PRATERRO_CDPRODUTO,
                                            @C_PRATERRO_IDCNTRESTOQ,
                                            @C_PRATERRO_IDPRODATIV,
                                            @C_PRATERRO_IDPRODATIVPR,
                                            @C_PRATERRO_IDCTRLESTQ;
      END; /*PRATOS*/
      CLOSE C_PRATERRO;
      DEALLOCATE C_PRATERRO;

      IF (@V_PRATNMDUPL > 0) BEGIN

          SET @V_EXISTS = @V_EXISTS + 1;
          SET @V_PRATOS = @V_PRATOS + 1;
          INSERT INTO LOGINTRECCENT
             (NRLOGINTCENT,
              CDFILDESTLOG,
              CDPRATOLOG,
              CDFAPRAORIGLOG,
              CDFAPRADESTL,
              CDFILORIGLOGREC,
              CDPRODUTO,
              IDTIPORECELOG,
              IDNUMEROERRO)
          VALUES
            (@V_NRLOGINTCENT,
             @P_CDFILIDEST,
             @C_PRATOSORIG_CDPRATO,
             @C_PRATOSORIG_CDFILAUXPRAT,
             @V_FILAUXDEST,
             @P_CDFILIORIG,
             @V_PRODUTO,
             'N',
             '2');
      END;



      SET @V_ERROS = (@V_ERROS + @V_EXISTS);

      IF (((@V_CONTRS = 0) OR (@V_CONTRF = 0)) AND (@V_PRATOS = 0)) BEGIN
         /* PRATOS */
         IF (@C_PRATOSORIG_CDFILAUXPRAT <> 'P') BEGIN
            SET @V_CONTPRAT = 0;
            SELECT
               @V_CONTPRAT = COUNT(*),
               @V_NMPRATODEST = MAX(NMPRATO)
            FROM PRATO
            WHERE
               CDPRATO = @C_PRATOSORIG_CDPRATO AND
               CDFILAUXPRAT = @P_CDFILIDEST;

            IF (@V_CONTPRAT = 0) BEGIN
               SET @V_IDOPERACAOP = 'S';
               INSERT INTO PRATO
               (CDFILAUXPRAT,
                CDPRATO,
                CDFILIAL,
                NMPRATO,
                CDNVPRATO,
                SGUNIDADE,
                VRARREDTRANS,
                CDSEGMER,
                CDEXPRATO)
               VALUES
               (@P_CDFILIDEST,
                @C_PRATOSORIG_CDPRATO,
                @P_CDFILIDEST,
                @C_PRATOSORIG_NMPRATO,
                @C_PRATOSORIG_CDNVPRATO,
                @C_PRATOSORIG_SGUNIDADE,
                @C_PRATOSORIG_VRARREDTRANS,
                @C_PRATOSORIG_CDSEGMER,
                @C_PRATOSORIG_CDEXPRATO);
            END
            ELSE BEGIN
               IF RTRIM(LTRIM(UPPER(@C_PRATOSORIG_NMPRATO))) = RTRIM(LTRIM(UPPER(@V_NMPRATODEST))) BEGIN
                  SET @V_IDOPERACAOP = 'S';
               END
               ELSE BEGIN
                  SET @V_IDOPERACAOP = 'I';
               END;
            END;
         END;

         SET @V_CDFILAUX = @C_PRATOSORIG_CDFILAUXPRAT;
         IF (@V_CDFILAUX <> 'P') BEGIN
            SET @V_CDFILAUX = @P_CDFILIDEST;
         END;

         /* RECEITAS */
         IF (@V_IDOPERACAOP = 'S') BEGIN
            IF ((@V_IDRECEFILI = 'F') AND (@V_CONTRF = 0)) BEGIN
               SET @V_CONTRECEF = 0;
               SELECT
                  @V_CONTRECEF = COUNT(*)
               FROM RECEFILI
               WHERE
                  CDPRATO = @C_PRATOSORIG_CDPRATO AND
                  CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT AND
                  CDFILIAL = @P_CDFILIORIG;

               IF (@V_CONTRECEF > 0) BEGIN

                  DELETE FROM RECEFILI
                  WHERE
                     CDPRATO = @C_PRATOSORIG_CDPRATO AND
                     CDFILAUXPRAT = @V_CDFILAUX AND
                     CDFILIAL = @P_CDFILIDEST;

                  INSERT INTO RECEFILI
                  (CDFILAUXPRAT,
                   CDPRATO,
                   CDFILIAL,
                   CDPRODUTO,
                   QTPRODRECLOC,
                   VRPEFATCOCLO,
                   VRPEFATCORLO,
                   HRTEMPPREPLO,
                   SGUNIDADE,
                   QTUNIDESTLO,
                   QTBRUTALO,
                   IDPRODBASELO,
                   CDAPRERECE,
                   DTULTATURECF,
                   VRPEFATNUTLO,
                   QTCALCNUTRLO,
                   QTBRUTALOUNR,
                   VRPERCDEGELO)
                  (SELECT
                      @V_CDFILAUX,
                      R.CDPRATO,
                      P_CDFILIDEST,
                      R.CDPRODUTO,
                      R.QTPRODRECLOC,
                      R.VRPEFATCOCLO,
                      R.VRPEFATCORLO,
                      R.HRTEMPPREPLO,
                      R.SGUNIDADE,
                      R.QTUNIDESTLO,
                      R.QTBRUTALO,
                      R.IDPRODBASELO,
                      R.CDAPRERECE,
                      GETDATE(),
                      R.VRPEFATNUTLO,
                      R.QTCALCNUTRLO,
                      R.QTBRUTALOUNR,
                      R.VRPERCDEGELO
                   FROM PRODUTO P,
                        (SELECT
                            CDPRATO,
                            CDPRODUTO,
                            QTPRODRECLOC,
                            VRPEFATCOCLO,
                            VRPEFATCORLO,
                            HRTEMPPREPLO,
                            SGUNIDADE,
                            QTUNIDESTLO,
                            QTBRUTALO,
                            IDPRODBASELO,
                            CDAPRERECE,
                            VRPEFATNUTLO,
                            QTCALCNUTRLO,
                            QTBRUTALOUNR,
			    VRPERCDEGELO,
                            @P_CDFILIDEST AS P_CDFILIDEST
                        FROM
                          RECEFILI R
                        WHERE
                           (R.CDPRATO       = @C_PRATOSORIG_CDPRATO)      AND
                           (R.CDFILAUXPRAT  = @C_PRATOSORIG_CDFILAUXPRAT) AND
                           (R.CDFILIAL      = @P_CDFILIORIG)) R
                      LEFT JOIN PRODFILI PF ON
                        ((PF.CDFILIAL  = R.P_CDFILIDEST) AND
                         (PF.CDPRODUTO = R.CDPRODUTO))
                   WHERE
                      (R.CDPRODUTO     = P.CDPRODUTO)      AND
                      (ISNULL(PF.IDCNTRESTOQ, 'S') = 'S')  AND
                      (ISNULL(PF.IDPRODATIV, 'A') = 'A')   AND
                      (P.IDPRODATIVPR = 'S') );
               END;

               SET @V_CONTRECEF = 0;
               SELECT @V_CONTRECEF = COUNT(*)
               FROM PRATFILI
               WHERE
                  CDPRATO = @C_PRATOSORIG_CDPRATO AND
                  CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT AND
                  CDFILIAL = @P_CDFILIORIG;

               IF (@V_CONTRECEF > 0) BEGIN
                  DELETE FROM PRATFILI
                  WHERE
                     CDPRATO = @C_PRATOSORIG_CDPRATO AND
                     CDFILAUXPRAT = @V_CDFILAUX AND
                     CDFILIAL = @P_CDFILIDEST;

                  INSERT INTO PRATFILI
                  (CDFILAUXPRAT,
                   CDPRATO,
                   CDFILIAL,
                   NRCORPRIFILI,
                   NRCORSEQFILI,
                   NRCORAUXFILI,
                   QTPADRAOFILI,
                   QTCONTAIFILI,
                   HRVALCONFILI,
                   NMFANTASIAPF,
                   QTCARBOPRFIL,
                   QTLIPIDPRFIL,
                   QTPROTEPRFIL,
                   QTCALORPRFIL,
                   QTALCOOPRFIL)
                  (SELECT
                      @V_CDFILAUX,
                      CDPRATO,
                      @P_CDFILIDEST,
                      NRCORPRIFILI,
                      NRCORSEQFILI,
                      NRCORAUXFILI,
                      QTPADRAOFILI,
                      QTCONTAIFILI,
                      HRVALCONFILI,
                      NMFANTASIAPF,
                      QTCARBOPRFIL,
                      QTLIPIDPRFIL,
                      QTPROTEPRFIL,
                      QTCALORPRFIL,
                      QTALCOOPRFIL
                   FROM PRATFILI
                   WHERE
                      CDPRATO = @C_PRATOSORIG_CDPRATO AND
                      CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT AND
                      CDFILIAL = @P_CDFILIORIG);
               END;
            END;
            IF ((@V_IDRECESERV = 'S') AND (@V_CONTRS = 0)) BEGIN
               SET @V_SERVORIGDEST = ''; /* NO COLOCAR NULL */
               DECLARE C_SERVICO CURSOR FOR
               SELECT
                   O.CDSERVFILI, O.NMSERVICO
                FROM
                   SERVICO O,
                   SERVICO D
                WHERE
                   (O.CDFILIAL = @P_CDFILIORIG) AND
                   (D.CDFILIAL = @P_CDFILIDEST) AND
                   (O.CDSERVFILI = D.CDSERVFILI) AND
                   (UPPER(RTRIM(LTRIM(O.NMSERVICO))) = UPPER(RTRIM(LTRIM(D.NMSERVICO)))) AND
                   EXISTS(SELECT CDPRATO
                          FROM RECESERV
                          WHERE
                             CDPRATO = @C_PRATOSORIG_CDPRATO AND
                             CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT AND
                             CDFILIAL = @P_CDFILIORIG AND
                             CDSERVFILI = O.CDSERVFILI);
               OPEN C_SERVICO;
               FETCH NEXT FROM C_SERVICO INTO @C_SERVICO_CDSERVFILI,
                                              @C_SERVICO_NMSERVICO;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_SERVORIGDEST = @V_SERVORIGDEST + @C_SERVICO_CDSERVFILI + '_';

                  FETCH NEXT FROM C_SERVICO INTO @C_SERVICO_CDSERVFILI,
                                                 @C_SERVICO_NMSERVICO;
               END;
               CLOSE C_SERVICO;
               DEALLOCATE C_SERVICO;

               DELETE FROM RECESERV
               WHERE
                  CDPRATO = @C_PRATOSORIG_CDPRATO AND
                  CDFILAUXPRAT = @V_CDFILAUX AND
                  CDFILIAL = @P_CDFILIDEST  AND
                  CHARINDEX(CDSERVFILI,@V_SERVORIGDEST) <> 0;

               INSERT INTO RECESERV
               (CDFILAUXPRAT,
                CDPRATO,
                CDFILIAL,
                CDSERVFILI,
                CDPRODUTO,
                QTPRODRECSER,
                VRPEFATCOCSE,
                VRPEFATCORSE,
                HRTEMPPREPSE,
                SGUNIDADE,
                QTUNIDESTSE,
                QTBRUTASE,
                IDPRODBASESE,
                CDAPRERECE,
                DTULTATURECS,
                VRPEFATNUTSE,
                QTCALCNUTRSE,
                QTBRUTASEUNR,
		VRPERCDEGELO)
               (SELECT
                   @V_CDFILAUX,
                   R.CDPRATO,
                   @P_CDFILIDEST,
                   R.CDSERVFILI,
                   R.CDPRODUTO,
                   R.QTPRODRECSER,
                   R.VRPEFATCOCSE,
                   R.VRPEFATCORSE,
                   R.HRTEMPPREPSE,
                   R.SGUNIDADE,
                   R.QTUNIDESTSE,
                   R.QTBRUTASE,
                   R.IDPRODBASESE,
                   R.CDAPRERECE,
                   GETDATE(),
                   R.VRPEFATNUTSE,
                   R.QTCALCNUTRSE,
                   R.QTBRUTASEUNR,
		   R.VRPERCDEGELO
                FROM PRODUTO P,
                  (SELECT
                      CDPRATO,
                      CDSERVFILI,
                      CDPRODUTO,
                      QTPRODRECSER,
                      VRPEFATCOCSE,
                      VRPEFATCORSE,
                      HRTEMPPREPSE,
                      SGUNIDADE,
                      QTUNIDESTSE,
                      QTBRUTASE,
                      IDPRODBASESE,
                      CDAPRERECE,
                      VRPEFATNUTSE,
                      QTCALCNUTRSE,
                      QTBRUTASEUNR,
		      VRPERCDEGELO,	
                      @P_CDFILIDEST AS P_CDFILIDEST
                   FROM RECESERV
                   WHERE
                      (CDPRATO      = @C_PRATOSORIG_CDPRATO)       AND
                      (CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT)  AND
                      (CDFILIAL     = @P_CDFILIORIG)               AND
                      (CHARINDEX(CDSERVFILI, @V_SERVORIGDEST) <> 0)) R
                   LEFT JOIN PRODFILI PF ON
                   ((PF.CDFILIAL  = R.P_CDFILIDEST) AND
                    (PF.CDPRODUTO = R.CDPRODUTO))
                WHERE
                   (R.CDPRODUTO     = P.CDPRODUTO)     AND
                   (ISNULL(PF.IDCNTRESTOQ, 'S') = 'S') AND
                   (ISNULL(PF.IDPRODATIV, 'A') = 'A')  AND
                   (P.IDPRODATIVPR = 'S') );

               SET @V_SERVORIGDEST = NULL;
               DECLARE C_SERVICO CURSOR FOR
               SELECT
                  O.CDSERVFILI, O.NMSERVICO
               FROM
                  SERVICO O,
                  SERVICO D
               WHERE
                  (O.CDFILIAL = @P_CDFILIORIG) AND
                  (D.CDFILIAL = @P_CDFILIDEST) AND
                  (O.CDSERVFILI = D.CDSERVFILI) AND
                  (UPPER(RTRIM(LTRIM(O.NMSERVICO))) = UPPER(RTRIM(LTRIM(D.NMSERVICO)))) AND
                  EXISTS(SELECT CDPRATO
                         FROM PRATSERV
                         WHERE
                            CDPRATO = @C_PRATOSORIG_CDPRATO AND
                            CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT AND
                            CDFILIAL = @P_CDFILIORIG AND
                            CDSERVFILI = O.CDSERVFILI);
               OPEN C_SERVICO;
               FETCH NEXT FROM C_SERVICO INTO @C_SERVICO_CDSERVFILI,
                                              @C_SERVICO_NMSERVICO;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_SERVORIGDEST = @V_SERVORIGDEST + @C_SERVICO_CDSERVFILI + '_';

                  FETCH NEXT FROM C_SERVICO INTO @C_SERVICO_CDSERVFILI,
                                                 @C_SERVICO_NMSERVICO;
               END;
               CLOSE C_SERVICO;
               DEALLOCATE C_SERVICO;

               DELETE FROM PRATSERV
               WHERE
                  CDPRATO = @C_PRATOSORIG_CDPRATO AND
                  CDFILAUXPRAT = @V_CDFILAUX AND
                  CDFILIAL = @P_CDFILIDEST  AND
                  CHARINDEX(CDSERVFILI, @V_SERVORIGDEST) <> 0;

               INSERT INTO PRATSERV
               (CDFILAUXPRAT,
                CDPRATO,
                CDFILIAL,
                CDSERVFILI,
                NRCORPRISERV,
                NRCORSEQSERV,
                NRCORAUXSERV,
                QTPADRAOSERV,
                QTCONTAISERV,
                HRVALCONSERV,
                NMFANTASIASE,
                QTCARBOPRSER,
                QTLIPIDPRSER,
                QTPROTEPRSER,
                QTCALORPRSER,
                QTALCOOPRSER)
               (SELECT
                   @V_CDFILAUX,
                   CDPRATO,
                   @P_CDFILIDEST,
                   CDSERVFILI,
                   NRCORPRISERV,
                   NRCORSEQSERV,
                   NRCORAUXSERV,
                   QTPADRAOSERV,
                   QTCONTAISERV,
                   HRVALCONSERV,
                   NMFANTASIASE,
                   QTCARBOPRSER,
                   QTLIPIDPRSER,
                   QTPROTEPRSER,
                   QTCALORPRSER,
                   QTALCOOPRSER
                FROM PRATSERV
                WHERE
                   CDPRATO = @C_PRATOSORIG_CDPRATO AND
                   CDFILAUXPRAT = @C_PRATOSORIG_CDFILAUXPRAT AND
                   CDFILIAL = @P_CDFILIORIG AND
                   CHARINDEX(CDSERVFILI, @V_SERVORIGDEST) <> 0);
            END;
         END;
      END;
      FETCH NEXT FROM C_PRATOSORIG INTO @C_PRATOSORIG_CDPRATO,
                                        @C_PRATOSORIG_CDFILAUXPRAT,
                                        @C_PRATOSORIG_NMPRATO,
                                        @C_PRATOSORIG_CDNVPRATO,
                                        @C_PRATOSORIG_SGUNIDADE,
                                        @C_PRATOSORIG_VRARREDTRANS,
                                        @C_PRATOSORIG_CDSEGMER,
                                        @C_PRATOSORIG_CDEXPRATO;

   END; /*PRATOS*/
   CLOSE C_PRATOSORIG;
   DEALLOCATE C_PRATOSORIG;
   IF (@V_ERROS > 0) BEGIN
      SET @P_NRLOGINTCENT = @V_NRLOGINTCENT;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'INTEGRA_RECEITA_CENTRALIZADA','6.35.044';
GO
