ZeedhiChart.directive("zhMaps", function() {
	return {
		link: function(scope, element, attrs) {

			var map;
			var polygon = new google.maps.Polygon();
			var geocoder = new google.maps.Geocoder();
			
			map = new google.maps.Map(element[0], {
				zoom: 16,
			    center: {lat: -19.912998, lng: -43.940933}
			});

			//--------- Events ---------
			/*Geocoder for subsidiary's address.
			  It'll build up polygonCoordinates array and populate it with coordinates of a radius around the subsidiary's address.
			  Then it will construct the polygon.*/
			google.maps.event.addListenerOnce(map, 'idle', function() {
				scope.loadFirstAddressGeocode(geocoder, map);
			});

			scope.loadFirstAddressGeocode = function(geocoder, resultsMap) {
				//If it's a new polygon
				if(scope.widget.isNewArea){
					var polygonCoordinates = [];

					// Construct the polygon.
					polygon = new google.maps.Polygon({
						paths: polygonCoordinates,
						strokeColor: '#FF0000',
						strokeOpacity: 0.4,
						strokeWeight: 2,
						fillColor: '#FF0000',
						fillOpacity: 0.05,
						editable: true,
						draggable: true
					});

					polygon.setMap(map);

					//Listener for generating a new polygon on map click event
					map.addListener('click', function(event) {
						if(!scope.widget.isFirstInsertion){
							//Second click, for inserting a new polygon
							//Check if user wants to erase polygon
							var erase = confirm('Deseja apagar o polígono já existente?');
							if(erase == true){
								polygon.setMap(null);
								var polygonCoordinates = [
									{lat: (event.latLng.lat() - 0.001), lng: (event.latLng.lng() - 0.001)},
									{lat: (event.latLng.lat() + 0.001), lng: (event.latLng.lng() - 0.001)},
									{lat: (event.latLng.lat() + 0.001), lng: (event.latLng.lng() + 0.001)},
									{lat: (event.latLng.lat() - 0.001), lng: (event.latLng.lng() + 0.001)}
								];

								// Construct the polygon.
								polygon = new google.maps.Polygon({
									paths: polygonCoordinates,
									strokeColor: '#FF0000',
									strokeOpacity: 0.4,
									strokeWeight: 2,
									fillColor: '#FF0000',
									fillOpacity: 0.05,
									editable: true,
									draggable: true
								});

								polygon.setMap(map);

								//This is ugly, but it has to be done here, otherwise we'll have scope issues.
								// --------- Get polygon's initial coordinates. ---------
								// Since this polygon has only one path, we can call getPath() to return the
								// MVCArray of LatLngs.
								var vertices = polygon.getPath();

								var contentString = [];

								// Iterate over the vertices.
								for (var i =0; i < vertices.getLength(); i++) {
									var xy = vertices.getAt(i);
									contentString.push(xy.lat() + ',' + xy.lng());
								}

								scope.widget.coordinates = contentString;
								// --------- End get polygon's initial coordinates. ---------



								// --------- Get polygon on vertices change ---------
								polygon.addListener('click', function(event){
									// Since this polygon has only one path, we can call getPath() to return the
									// MVCArray of LatLngs.
									var vertices = this.getPath();

									var contentString = [];

									// Iterate over the vertices.
									for (var i =0; i < vertices.getLength(); i++) {
										var xy = vertices.getAt(i);
										contentString.push(xy.lat() + ',' + xy.lng());
									}

									scope.widget.coordinates = contentString;
								});

								//Triggers the polygon 'click' listener to update coordinates
								vertices.addListener('set_at', function(event) {
									google.maps.event.trigger(polygon, 'click', {});
								});

								vertices.addListener('insert_at', function(event) {
									google.maps.event.trigger(polygon, 'click', {});
								});
								// --------- End get polygon vertices change ---------
							}
						} else {
							scope.widget.isFirstInsertion = false;
							var polygonCoordinates = [
								{lat: (event.latLng.lat() - 0.001), lng: (event.latLng.lng() - 0.001)},
								{lat: (event.latLng.lat() + 0.001), lng: (event.latLng.lng() - 0.001)},
								{lat: (event.latLng.lat() + 0.001), lng: (event.latLng.lng() + 0.001)},
								{lat: (event.latLng.lat() - 0.001), lng: (event.latLng.lng() + 0.001)}
							];

							// Construct the polygon.
							polygon = new google.maps.Polygon({
								paths: polygonCoordinates,
								strokeColor: '#FF0000',
								strokeOpacity: 0.4,
								strokeWeight: 2,
								fillColor: '#FF0000',
								fillOpacity: 0.05,
								editable: true,
								draggable: true
							});

							polygon.setMap(map);

							//This is ugly, but it has to be done here, otherwise we'll have scope issues.
							// --------- Get polygon's initial coordinates. ---------
							// Since this polygon has only one path, we can call getPath() to return the
							// MVCArray of LatLngs.
							var vertices = polygon.getPath();

							var contentString = [];

							// Iterate over the vertices.
							for (var i =0; i < vertices.getLength(); i++) {
								var xy = vertices.getAt(i);
								contentString.push(xy.lat() + ',' + xy.lng());
							}

							scope.widget.coordinates = contentString;
							// --------- End get polygon's initial coordinates. ---------



							// --------- Get polygon on vertices change ---------
							polygon.addListener('click', function(event){
								// Since this polygon has only one path, we can call getPath() to return the
								// MVCArray of LatLngs.
								var vertices = this.getPath();

								var contentString = [];

								// Iterate over the vertices.
								for (var i =0; i < vertices.getLength(); i++) {
									var xy = vertices.getAt(i);
									contentString.push(xy.lat() + ',' + xy.lng());
								}

								scope.widget.coordinates = contentString;
							});

							//Triggers the polygon 'click' listener to update coordinates
							vertices.addListener('set_at', function(event) {
								google.maps.event.trigger(polygon, 'click', {});
							});

							vertices.addListener('insert_at', function(event) {
								google.maps.event.trigger(polygon, 'click', {});
							});
							// --------- End get polygon vertices change ---------
						}
					});
				} else {
					//Build the polygon that is already registered defining the LatLng coordinates for the polygon's path.
					var polygonCoordinates = [];
					widgetCoordinates = scope.widget.coordinates;
					widgetCoordinates.forEach(function(coord){
						var coordinate = {lat: parseFloat(coord.substr(0, coord.indexOf(','))), lng: parseFloat(coord.substr(coord.indexOf(',') + 1, coord.length))}
						polygonCoordinates.push(coordinate);
					});

					//Set center for map using polygon's center coordinate
					var bounds = new google.maps.LatLngBounds();
					polygonCoordinates.forEach(function (polygonCoord){
						bounds.extend(new google.maps.LatLng(polygonCoord));
					});
					resultsMap.setCenter(bounds.getCenter());
					

					// Construct the polygon.
					polygon = new google.maps.Polygon({
						paths: polygonCoordinates,
						strokeColor: '#FF0000',
						strokeOpacity: 0.4,
						strokeWeight: 2,
						fillColor: '#FF0000',
						fillOpacity: 0.05,
						editable: true,
						draggable: true
					});

					polygon.setMap(map);

					// --------- Check if clicked coordinate is inside the polygon ---------
					/*google.maps.event.addListener(map, 'click', function(e) {
						console.log(google.maps.geometry.poly.containsLocation(e.latLng, polygon));
					});
					google.maps.event.addListener(polygon, 'click', function(e) {
						console.log(google.maps.geometry.poly.containsLocation(e.latLng, polygon));
					});*/
					// --------- End check if clicked coordinate is inside the polygon ---------


					//This is ugly, but it has to be done here, otherwise we'll have scope issues.
					// --------- Get polygon's initial coordinates. ---------
					// Since this polygon has only one path, we can call getPath() to return the
					// MVCArray of LatLngs.
					var vertices = polygon.getPath();

					var contentString = [];

					// Iterate over the vertices.
					for (var i =0; i < vertices.getLength(); i++) {
						var xy = vertices.getAt(i);
						contentString.push(xy.lat() + ',' + xy.lng());
					}

					scope.widget.coordinates = contentString;
					// --------- End get polygon's initial coordinates. ---------



					// --------- Get polygon on vertices change ---------
					polygon.addListener('click', function(event){
						// Since this polygon has only one path, we can call getPath() to return the
						// MVCArray of LatLngs.
						var vertices = this.getPath();

						var contentString = [];

						// Iterate over the vertices.
						for (var i =0; i < vertices.getLength(); i++) {
							var xy = vertices.getAt(i);
							contentString.push(xy.lat() + ',' + xy.lng());
						}

						scope.widget.coordinates = contentString;
					});

					//Triggers the polygon 'click' listener to update coordinates
					vertices.addListener('set_at', function(event) {
						google.maps.event.trigger(polygon, 'click', {});
					});
					
					vertices.addListener('insert_at', function(event) {
						google.maps.event.trigger(polygon, 'click', {});
					});
					// --------- End get polygon vertices change ---------

					//Listener for generating a new polygon on map click event
					map.addListener('click', function(event) {
						//Second click, for inserting a new polygon
						//Check if user wants to erase polygon
						var erase = confirm('Deseja apagar o polígono já existente?');
						if(erase == true){
							polygon.setMap(null);
							var polygonCoordinates = [
								{lat: (event.latLng.lat() - 0.001), lng: (event.latLng.lng() - 0.001)},
								{lat: (event.latLng.lat() + 0.001), lng: (event.latLng.lng() - 0.001)},
								{lat: (event.latLng.lat() + 0.001), lng: (event.latLng.lng() + 0.001)},
								{lat: (event.latLng.lat() - 0.001), lng: (event.latLng.lng() + 0.001)}
							];

							// Construct the polygon.
							polygon = new google.maps.Polygon({
								paths: polygonCoordinates,
								strokeColor: '#FF0000',
								strokeOpacity: 0.4,
								strokeWeight: 2,
								fillColor: '#FF0000',
								fillOpacity: 0.05,
								editable: true,
								draggable: true
							});

							polygon.setMap(map);

							//This is ugly, but it has to be done here, otherwise we'll have scope issues.
							// --------- Get polygon's initial coordinates. ---------
							// Since this polygon has only one path, we can call getPath() to return the
							// MVCArray of LatLngs.
							var vertices = polygon.getPath();

							var contentString = [];

							// Iterate over the vertices.
							for (var i =0; i < vertices.getLength(); i++) {
								var xy = vertices.getAt(i);
								contentString.push(xy.lat() + ',' + xy.lng());
							}

							scope.widget.coordinates = contentString;
							// --------- End get polygon's initial coordinates. ---------



							// --------- Get polygon on vertices change ---------
							polygon.addListener('click', function(event){
								// Since this polygon has only one path, we can call getPath() to return the
								// MVCArray of LatLngs.
								var vertices = this.getPath();

								var contentString = [];

								// Iterate over the vertices.
								for (var i =0; i < vertices.getLength(); i++) {
									var xy = vertices.getAt(i);
									contentString.push(xy.lat() + ',' + xy.lng());
								}

								scope.widget.coordinates = contentString;
							});

							//Triggers the polygon 'click' listener to update coordinates
							vertices.addListener('set_at', function(event) {
								google.maps.event.trigger(polygon, 'click', {});
							});

							vertices.addListener('insert_at', function(event) {
								google.maps.event.trigger(polygon, 'click', {});
							});
							// --------- End get polygon vertices change ---------
						}
					});
				}
			}

			scope.geocodeAddress = function(geocoder, resultsMap) {
				var address = document.getElementById('address').value;
				if(address !== ""){
					geocoder.geocode({'address': address}, function(results, status) {
						if (status === google.maps.GeocoderStatus.OK) {
								resultsMap.setCenter(results[0].geometry.location);
								var marker = new google.maps.Marker({
									map: resultsMap,
									position: results[0].geometry.location
								});
						} else {
							alert('Endereço não encontrado.');
						}
					});
				} else {
					alert('Endereço não encontrado.');
				}
			}

			/*Getter for user's address input.*/
			document.getElementById('submit').addEventListener('click', function() {
				scope.geocodeAddress(geocoder, map);
			});
		}

	};
});